<?php

namespace fk_\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfKSozlesmeBolge ArrayType
 * @subpackage Arrays
 */
class ArrayOfKSozlesmeBolge extends AbstractStructArrayBase
{
    /**
     * The KSozlesmeBolge
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \fk_\StructType\KSozlesmeBolge[]
     */
    public $KSozlesmeBolge;
    /**
     * Constructor method for ArrayOfKSozlesmeBolge
     * @uses ArrayOfKSozlesmeBolge::setKSozlesmeBolge()
     * @param \fk_\StructType\KSozlesmeBolge[] $kSozlesmeBolge
     */
    public function __construct(array $kSozlesmeBolge = array())
    {
        $this
            ->setKSozlesmeBolge($kSozlesmeBolge);
    }
    /**
     * Get KSozlesmeBolge value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \fk_\StructType\KSozlesmeBolge[]|null
     */
    public function getKSozlesmeBolge()
    {
        return isset($this->KSozlesmeBolge) ? $this->KSozlesmeBolge : null;
    }
    /**
     * This method is responsible for validating the values passed to the setKSozlesmeBolge method
     * This method is willingly generated in order to preserve the one-line inline validation within the setKSozlesmeBolge method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateKSozlesmeBolgeForArrayConstraintsFromSetKSozlesmeBolge(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfKSozlesmeBolgeKSozlesmeBolgeItem) {
            // validation for constraint: itemType
            if (!$arrayOfKSozlesmeBolgeKSozlesmeBolgeItem instanceof \fk_\StructType\KSozlesmeBolge) {
                $invalidValues[] = is_object($arrayOfKSozlesmeBolgeKSozlesmeBolgeItem) ? get_class($arrayOfKSozlesmeBolgeKSozlesmeBolgeItem) : sprintf('%s(%s)', gettype($arrayOfKSozlesmeBolgeKSozlesmeBolgeItem), var_export($arrayOfKSozlesmeBolgeKSozlesmeBolgeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The KSozlesmeBolge property can only contain items of type \fk_\StructType\KSozlesmeBolge, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set KSozlesmeBolge value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \fk_\StructType\KSozlesmeBolge[] $kSozlesmeBolge
     * @return \fk_\ArrayType\ArrayOfKSozlesmeBolge
     */
    public function setKSozlesmeBolge(array $kSozlesmeBolge = array())
    {
        // validation for constraint: array
        if ('' !== ($kSozlesmeBolgeArrayErrorMessage = self::validateKSozlesmeBolgeForArrayConstraintsFromSetKSozlesmeBolge($kSozlesmeBolge))) {
            throw new \InvalidArgumentException($kSozlesmeBolgeArrayErrorMessage, __LINE__);
        }
        if (is_null($kSozlesmeBolge) || (is_array($kSozlesmeBolge) && empty($kSozlesmeBolge))) {
            unset($this->KSozlesmeBolge);
        } else {
            $this->KSozlesmeBolge = $kSozlesmeBolge;
        }
        return $this;
    }
    /**
     * Add item to KSozlesmeBolge value
     * @throws \InvalidArgumentException
     * @param \fk_\StructType\KSozlesmeBolge $item
     * @return \fk_\ArrayType\ArrayOfKSozlesmeBolge
     */
    public function addToKSozlesmeBolge(\fk_\StructType\KSozlesmeBolge $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \fk_\StructType\KSozlesmeBolge) {
            throw new \InvalidArgumentException(sprintf('The KSozlesmeBolge property can only contain items of type \fk_\StructType\KSozlesmeBolge, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->KSozlesmeBolge[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \fk_\StructType\KSozlesmeBolge|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \fk_\StructType\KSozlesmeBolge|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \fk_\StructType\KSozlesmeBolge|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \fk_\StructType\KSozlesmeBolge|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \fk_\StructType\KSozlesmeBolge|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string KSozlesmeBolge
     */
    public function getAttributeName()
    {
        return 'KSozlesmeBolge';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \fk_\ArrayType\ArrayOfKSozlesmeBolge
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
